SUBSGA ;
 	ORG	0000
 ;
 ; START ROUTINE #0 -- GET ADDRESS AND JUMP
 	CALL	0A7FH
 	PUSH	HL
 	RET
 ;
 ; SCREEN WHITE-OUT ... ROUTINE #0A
 	LD	HL,3C00H
 	LD	DE,3C01H
 	LD	BC,03FFH
 	LD	(HL),0BFH
 	LDIR
 	RET
 ;
 ; SCREEN REVERSE ... ROUTINE #0B
 	LD	HL,3C00H
 LOOP1	LD	A,(HL)
 	CPL
 	LD	(HL),A
 	INC	HL
 	LD	A,H
 	CP	40H
 	JR	NZ,LOOP1
 	RET
 ;
 ;
 	ORG	0000
 ;
 ; SOUND OUTPUT ... ROUTINE #1
 	CALL	0A7FH
 	PUSH	HL
 	LD	DE,0180H
 	EX	DE,HL
 	SBC	HL,DE
 	EX	DE,HL
 LOOP2	POP	BC
 	PUSH	BC
 	LD	A,(403DH)
 	OR	2
 	OUT	(0FFH),A
 DELAY1	DEC	BC
 	LD	A,B
 	OR	C
 	JR	NZ,DELAY1
 	POP	BC
 	PUSH	BC
 	LD	A,(403DH)
 	OUT	(0FFH),A
 DELAY2	DEC	BC
 	LD	A,B
 	OR	C
 	JR	NZ,LOOP2
 	DEC	DE
 	LD	A,D
 	OR	E
 	JR	NZ,LOOP2
 	POP	HL
 	RET
 ;
 ;
 	ORG	0000
 ;
 ; VOICE OUTPUT ... ROUTINE #2
 	CALL	0A7FH
 	LD	DE,0400H
 	PUSH	DE
 	LD	A,(403DH)
 	LD	C,A
 LOOP4	LD	D,8
 	LD	A,(HL)
 	LD	E,A
 	XOR	A
 LOOP5	RL	E
 	RL	A
 	OR	C
 	OUT	(0FFH),A
 	LD	B,6
 DELAY3	DJNZ	DELAY3
 	XOR	A
 	DEC	D
 	JR	NZ,LOOP5
 	INC	HL
 	POP	DE
 	DEC	DE
 	PUSH	DE
 	LD	A,D
 	OR	E
 	JR	NZ,LOOP4
 	POP	DE
 	RET
 ;
 ;
 	ORG	0000
 ;
 ; START ROUTINE #3 -- GET START ADDRESS AND JUMP
 	CALL	0A7FH
 	PUSH	HL
 	RET
 ;
 ; UPWARD SCROLL ... ROUTINE #3A
 	LD	HL,3C40H
 	LD	DE,3C00H
 	LD	BC,0380H
 	LDIR
 	RET
 ;
 ; DOWNWARD SCROLL ... ROUTINE #3B
 	LD	HL,3F7FH
 	LD	DE,3FBFH
 	LD	BC,037FH
 	LDDR
 	RET
 ;
 ; RIGHTWARD SCROLL ... ROUTINE #3C
 	LD	HL,3FBEH
 	LD	DE,3FBFH
 	LD	BC,03FBH
 	LDDR
 	INC	HL
 	LD	(HL),20H
 	RET
 ;
 ; LEFTWARD SCROLL ... ROUTINE #3D
 	LD	HL,3C01H
 	LD	DE,3C00H
 	LD	BC,03BFH
 	LDIR
 	DEC	HL
 	LD	(HL),20H
 	RET
 ;
 ;
 	ORG	0000
 ;
 ; START ROUTINE #4 -- GET START ADDRESS AND JUMP
 	CALL	0A7FH
 	PUSH	HL
 	RET
 ;
 ; RIGHT CLEAR ... ROUTINE #4A
 	LD	HL,3C3FH
 	LD	DE,0040H
 	LD	B,0FH
 LOOP6	LD	(HL),20H
 	ADD	HL,DE
 	DJNZ	LOOP6
 	RET
 ;
 ; LEFT CLEAR ... ROUTINE #4B
 	LD	HL,3C00H
 	LD	DE,0040H
 	LD	B,0FH
 LOOP7	LD	(HL),20H
 	ADD	HL,DE
 	DJNZ	LOOP7
 	RET
 ;
 ;
 	ORG	0000
 ;
 ; LOAD TOP SCREEN FROM MEMORY ... ROUTINE #5A
 	CALL	0A7FH
 	LD	DE,3C00H	; CHANGE 3C00/3F80
 	LD	BC,0040H
 	LDIR
 	RET
 ;
 ;
 	ORG	0000
 ;
 ; LOAD BOTTOM SCREEN FROM MEMORY ... ROUTINE #5B
 	CALL	0A7FH
 	LD	DE,3F80H	; CHANGE 3F80/3C00
 	LD	BC,0040H
 	LDIR
 	RET
 ;
 ;
 	ORG	0000
 ;
 ; LOAD LEFT SCREEN FROM MEMORY ... ROUTINE #6A
 	CALL	0A7FH
 	LD	IX,3C00H	; CHANGE 3C00/3C3F
 	LD	DE,0040H
 	LD	B,0FH
 LOOP8	LD	A,(HL)
 	LD	(IX),A
 	ADD	HL,DE
 	ADD	IX,DE
 	DJNZ	LOOP8
 	RET
 ;
 ;
 	ORG	0000
 ;
 ; LOAD RIGHT SCREEN FROM MEMORY ... ROUTINE #6B
 	CALL	0A7FH
 	LD	IX,3C3FH	; CHANGE 3C3F/3C00
 	LD	DE,0040H
 	LD	B,0FH
 LOOP9	LD	A,(HL)
 	LD	(IX),A
 	ADD	HL,DE
 	ADD	IX,DE
 	DJNZ	LOOP9
 	RET
 ;
 	END
